function [A,b] = get_system(level)

N = 2^level+1;
h = 1/(N-1);
A = gallery('poisson', N-2)/h^2;

if nargout==2
  xx = linspace(0,1,N); xx = xx(2:end-1);
  [X,Y] = meshgrid(xx,xx);
  B = sin(X).*exp(X)+cos(Y.*Y);
  b = B(:);
  b = rand(size(b));
end

end