function [def_neg,def_pos]=def_interval_spring(n)

M=speye(n);
e = ones(n,1);
 K = (n+1)^2*full(spdiags([-e 2*e -e], -1:1, n, n));
 K=sparse(K);
 K = spdiags([-5*e 15*e -5*e], -1:1, n, n);%D = spdiags([-10*e 30*e -10*e], -1:1, n, n);
D=2*K;
%A=blkdiag(M, -K);B=[sparse(n,n) M;M D];%eig(full(A),full(B));

f_neg=zeros(1,n);f_pos=zeros(1,n);
for k=1:n,
        c=cos(k*pi/(n+1));
        %f([2*k-1 2*k])=roots([1, 30-20*c, 15-10*c]);
        f([2*k-1 2*k])=roots([1, D(1,1)+(D(1,2)+D(2,1))*c, K(1,1)+(K(1,2)+K(2,1))*c]);
        temp=sort(f([2*k-1 2*k]),'ascend');
        temp_neg=temp(1);
        temp_pos=temp(2);
        if k==1,
            def_neg=temp_neg;
            def_pos=temp_pos;
        else
           if (temp_neg>def_neg)
            def_neg=temp_neg;
           end
           if (temp_pos<def_pos)
            def_pos=temp_pos;
           end
        end
        f_neg(n-k+1)=temp_neg;
        f_pos(k)=temp_pos;
%         f([2*k-1 2*k])=sort(f([2*k-1 2*k]));
%         f_neg(n-k+1)=min(f([2*k-1 2*k]));
%         f_pos(k)=max(f([2*k-1 2*k]));
end

    fprintf('Definitennes interval for n=%d is: (%f,%f)\n',n,def_neg,def_pos)

% %   if n==1000
% %     fprintf('Definitennes interval for n=%d is: (%f,%f)\n',n,def_neg,def_pos)
% %     ff=sort(f_neg);%ff=max(ff)
% %     fff=sort(f_pos);%fff=min(fff)
% %     figure(1)
% %     subplot(3,1,1)
% %     plot(real(ff),imag(ff),'bo')
% %     hold on
% %     plot(real(fff),imag(fff),'r<')
% %     
% %     title('eigenvalues');
% %     axis([-50 20 -4 4])
% %     hold all
% %     subplot(3,1,2)
% %     plot(f_neg,'bx')
% %     title('B-negative eigenvalues');
% %     hold on
% %     subplot(3,1,3)
% %     plot(f_pos,'bx')
% %     title('B-positive eigenvalues');
% %     hold on
% %     figure(2)
% %     plot(real(f_pos(1:10)),imag(f_pos(1:10)),'ro')
% %     figure(3)
% %     plot(real(f_neg(n-5:n)),imag(f_neg(n-5:n)),'bo')
% %   
% %   end
% %   if n==2000
% %     fprintf('Definitennes interval for n=%d is: (%f,%f)\n',n,def_neg,def_pos)
% %     figure(1)
% %     subplot(3,1,1)
% %     plot(real(f),imag(f),'r>')
% %     title('eigenvalues');
% %     axis([-50 1 -4 4])
% %     hold all
% %     subplot(3,1,2)
% %     plot(f_neg,'r>')
% %     title('B-negative eigenvalues');
% %     hold on
% %     subplot(3,1,3)
% %     plot(f_pos,'r>')
% %     title('B-positive eigenvalues');
% %     hold on
% %     figure(4)
% %     plot(real(f_pos(1:10)),imag(f_pos(1:10)),'ro')
% %     figure(5)
% %     plot(real(f_neg(n-5:n)),imag(f_neg(n-5:n)),'bo')
% %       ff=sort(f_neg);ff=max(ff)
% %       fff=sort(f_pos);fff=min(fff)
% %   end







